A first solution for #5899

This commit is contained in:
ng0 2019-09-20 16:56:39 +00:00
parent 4021fc1cdc
commit c97daf46fc
No known key found for this signature in database
GPG Key ID: E22F9BBFEE348588
4 changed files with 181 additions and 86 deletions

4
.gitignore vendored
View File

@ -13,3 +13,7 @@ yarn-error.log
npm-packages-offline-cache/
config.mk
configure.py
\#*\#
*~

View File

@ -52,7 +52,7 @@ lint: tsc yarn-install
$(tslint) -e src/i18n/strings.ts --project tsconfig.json -t verbose 'src/**/*.ts' 'src/**/*.tsx'
.PHONY: yarn-install
yarn-install:
yarn-install:
yarn install
@ -83,7 +83,7 @@ else
.PHONY: install
install: tsc
@echo "installing to" $(prefix)
npm install -g --prefix $(prefix) .
npm install -g --prefix $(prefix) .
endif
.PHONY: watch

187
configure vendored
View File

@ -1,99 +1,118 @@
#!/usr/bin/env bash
#!/bin/sh
set -eu
# This file is part of TALER
# (C) 2019 GNUnet e.V.
#
# This is very simple POSIX sh script which
# identifies the first matching
# python3 identifier in $PATH and produces
# configure.py from configure.py.in, and then
# calls the new executable configure.py.
#
# It should be portable on Unices. Report bugs on
# the bugtracker if you discover that it isn't
# working as intended.
#
# Authors:
# Author: ng0 <ng0@taler.net>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
# OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
# WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
# ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
# THIS SOFTWARE.
#
# SPDX-License-Identifier: 0BSD
prefix=/usr/local
usage() {
echo "Usage: ./configure [OPTION]"
echo
echo "Configuration:"
echo " -h, --help display this help and exit"
echo
echo "Installation directories:"
echo " --prefix=PREFIX install architecture-independent files in PREFIX [$prefix]"
# there is a function used in curl to replicate which(1), but
# it uses too many other tools. this one uses command and in
# gnunet so far has no reports about failures.
existence()
{
command -v "$1" >/dev/null 2>&1
}
# -allow a command to fail with !'s side effect on errexit
# -use return value from ${PIPESTATUS[0]}, because ! hosed $?
! getopt --test > /dev/null
if [[ ${PIPESTATUS[0]} -ne 4 ]]; then
echo 'getopt not available'
exit 1
# We have to check every possible variant of the
# executable name because there is a PEP which
# defines the executable to be like this.
if existence python3; then
python="python3"
elif existence python3.1; then
python="python3.1"
elif existence python3.2; then
python="python3.2"
elif existence python3.3; then
python="python3.3"
elif existence python3.4; then
python="python3.4"
elif existence python3.5; then
python="python3.5"
elif existence python3.6; then
python="python3.6"
elif existence python3.7; then
python="python3.7"
elif existence python3.8; then
python="python3.8"
else
echo "*** No known python3 executable found in path ***"
echo "*** falling back to env(1) python ***"
# Unreliable, but if env finds no python, we still can
# not assume python in a fixed location.
# TODO: Check this in a clean chroot!
python="env python"
fi
LONGOPTS=prefix:,help
OPTIONS=h
# we could check the return value here via || echo "blafoo"
# or fail anyway once configure.py is invoked because we
# don't have python if we reach the point to fail.
PYTHON=$($python -c 'import sys; print(sys.executable)')
#echo $PYTHON
! PARSED=$(getopt --options=$OPTIONS --longoptions=$LONGOPTS --name "$0" -- "$@")
if [[ ${PIPESTATUS[0]} -ne 0 ]]; then
# e.g. return value is 1
# then getopt has complained about wrong arguments to stdout
exit 2
if ! existence node; then
echo 'Error: node executable not found.'
echo 'If you are using Linux, Ubuntu or Debian, try installing the'
echo 'node-legacy package or symlink node to nodejs.'
else
node_version=$(node --version)
#echo "Using node ${node_version}"
if ! node -p 'process.exit(!(/v([0-9]+)/.exec(process.version)[1] >= 4))'; then
echo 'Your node version is too old, use Node 4.x or newer'
fi
fi
# read getopt's output this way to handle the quoting right:
eval set -- "$PARSED"
while true; do
case "$1" in
--prefix)
prefix="$2"
shift 2
;;
-h|--help)
usage
exit 1
;;
--)
shift
break
;;
*)
echo "Programming error"
exit 3
;;
esac
done
cat << EOF > config.mk
# this file is autogenerated by ./configure
prefix=$prefix
EOF
node_version=$(node --version)
if [ ! "$?" -eq 0 ]; then
echo 'Error: node executable not found.'
echo 'If you are using ubuntu or debian, try installing the'
echo 'node-legacy package or symlink node to nodejs.'
exit 1
fi
echo "Using node ${node_version}"
if ! node -p 'process.exit(!(/v([0-9]+)/.exec(process.version)[1] >= 4))'; then
echo 'Your node version is too old, use something >v4.x.x'
exit 1
if ! existence yarn; then
echo 'ERROR: yarn missing. See https://yarnpkg.com/en/docs/install'
fi
if ! yarn --version &>/dev/null; then
echo 'Error: yarn missing. See https://yarnpkg.com/en/docs/install'
exit 1
# for the weird systems and sandboxes, only as a anotice.
# make will fail anyway.
if ! existence find; then
echo "INFO: find(1) is missing"
fi
if ! existence xargs; then
echo "INFO: xargs(1) is missing"
fi
if ! existence msgmerge; then
echo "INFO: msgmerge(1) is missing"
fi
if ! find --version &>/dev/null; then
echo 'Error: find missing'
exit 1
fi
if ! xargs --version &>/dev/null; then
echo 'Error: xargs missing'
exit 1
fi
if ! msgmerge --version &>/dev/null; then
echo "Warning: msgmerge missing, i18n won't work"
exit 1
fi
# Remove leftover configure.py file
rm configure.py
# Now we will just assume sed exists,
# and replace only the executable name.
sed -e "s,[@]PYTHON[@],$PYTHON,g" < ./configure.py.in > configure.py
chmod +x configure.py
# Call configure.py, assuming all went well.
# $1 is read by configure.py as the prefix.
# If $1 is empty, the python script checks the
# environment for PREFIX. We might need more
# variables and switches, such as DESTDIR.
./configure.py "$1"

72
configure.py.in Normal file
View File

@ -0,0 +1,72 @@
#!@PYTHON@
# This file is part of TALER
# (C) 2019 GNUnet e.V.
#
# Authors:
# Author: ng0 <ng0@taler.net>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
# OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
# WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
# ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
# THIS SOFTWARE.
#
# SPDX-License-Identifier: 0BSD
import argparse
import os
import sys
import logging
# This script so far generates config.mk.
# The only value it produces is prefix,
# which is either taken as the first argument
# to this script, or as --prefix=, or read
# from the environment variable PREFIX.
#
# TODO: Also respect DESTDIR ($PREFIX/$DESTDIR/rest).
def _read_prefix():
logging.basicConfig(level=logging.DEBUG)
logger = logging.getLogger(__name__)
if 'PREFIX' in os.environ:
logger.debug('PREFIX from environment')
myprefix = os.environ.get('PREFIX')
if myprefix is not None and os.path.isdir(myprefix) is True:
logger.debug('PREFIX from environment: %s', myprefix)
return myprefix
else:
logger.debug('PREFIX from argv')
parser = argparse.ArgumentParser()
parser.add_argument("-p",
"--prefix",
type=str,
required=True,
help='Directory prefix for installation')
logger.debug('parser.parse_args step')
args = parser.parse_args()
logger.debug('%s', args)
myprefix = args.prefix
# if args.prefix is not None and os.path.isdir(myprefix) is True:
if args.prefix and os.path.isdir(myprefix) is True:
return myprefix
def main():
myprefix = str(_read_prefix())
f = open('config.mk', 'w+')
f.write('# this file is autogenerated by ./configure\n')
f.write('prefix=' + myprefix + '\n')
f.close()
main()